commit f558f45deeae1bd9396231da41c96f695a28bf0c
Author: Guo Jie <guojie@loongson.cn>
Date:   Wed Oct 29 09:38:54 2025

    LoongArch: Standard instruction template fnmam4 correction
    
    The current implementation of the fnmam4 instruction template requires
    the third source operand to be assigned the same hard register as the
    target operand, but the constraint is not documented in the instruction
    manual or standard template definitions. The current constraint will
    generate additional data dependencies and extra instructions.
    
    gcc/ChangeLog:
    
            * config/loongarch/lasx.md (fnma<mode>4): Remove.
            * config/loongarch/lsx.md (fnma<mode>4): Remove.
            * config/loongarch/simd.md (fnma<mode>4): Simplify and correct.
    
    gcc/testsuite/ChangeLog:
    
            * gcc.target/loongarch/fnmam4-vec.c: New test.
    
    (cherry picked from commit 7811fb6fa35fd3c3694eba34fbfc992eed1d3e67)

diff --git a/gcc/testsuite/gcc.target/loongarch/fnmam4-vec.c b/gcc/testsuite/gcc.target/loongarch/fnmam4-vec.c
new file mode 100644
index 00000000000..09693039deb
--- /dev/null
+++ b/gcc/testsuite/gcc.target/loongarch/fnmam4-vec.c
@@ -0,0 +1,14 @@
+/* { dg-do compile } */
+/* { dg-options "-Ofast -mlasx -ftree-vectorize" } */
+/* { dg-require-effective-target loongarch_asx } */
+
+void
+foo (float *u, float x, float *y, float z)
+{
+  int i;
+  for (i = 0; i < 1024; i++)
+    *(u++) = (x - y[i] * z);
+}
+
+/* { dg-final { scan-assembler-not "\tvori.b"} } */
+/* { dg-final { scan-assembler-not "\txvori.b"} } */

